import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cT as LogMessage, a as LogHandler } from './uuid-f7f2f4f2.js';
export { dt as ArgumentsType, cl as AsyncMutex, cG as AsyncReturnType, V as BinInput, d1 as Channel, d0 as ChannelMessageEvent, df as CryptoEncoder, au as Currency, as as CurrencyInput, av as DAY_MS, aS as Day, ax as DayInput, aR as DayInputLegacy, aw as DayValue, aY as DecimalInput, aX as DecimalValue, d7 as DefaultListener, cb as Disposable, ca as Disposer, c9 as DisposerFunction, d8 as Emitter, d5 as EmitterAllHandler, d4 as EmitterHandler, dc as Encoder, J as Json, de as JsonEncoder, d6 as ListenerSignature, d2 as LocalChannel, a as LogHandler, L as LogHandlerOptions, c as LogLevel, cQ as LogLevelAlias, cR as LogLevelAliasKey, cS as LogLevelAliasType, cT as LogMessage, cP as Logger, cW as LoggerConsoleHandler, cV as LoggerContext, cU as LoggerContextInterface, b as LoggerInterface, c$ as LoggerMemoryHandler, dP as MemStorage, dO as MemStorageOptions, di as Message, dg as MessageAction, dm as MessageDefinitions, dn as MessageHub, dh as MessageResult, dk as MessagesDefaultMethods, dl as MessagesMethods, dj as MessagesOptions, ck as Mutex, dT as NestedArray, dd as NoopEncoder, O as ObjectStorage, cu as Pool, cq as PoolTask, cs as PoolTaskEvents, co as PoolTaskFn, cr as PoolTaskIdConflictResolution, cp as PoolTaskState, b6 as Primitive, dr as PubSub, dw as RPCFn, dv as RPCOptions, dx as RPCReturn, ao as RenderMessagesOptions, du as ReturnType, bE as RoundingMode, cJ as SerialQueue, bP as SortableItem, cI as TaskEvents, cH as TaskFn, a8 as Uint8ArrayToHexDump, a7 as Uint8ArrayToJson, Y as Uint8ArrayToString, cg as UseDefer, cd as UseDispose, c8 as XRX, W as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, E as arrayAvg, F as arrayBatches, t as arrayEmptyInPlace, q as arrayFilterInPlace, l as arrayFlatten, m as arrayIntersection, w as arrayIsEqual, B as arrayMax, C as arrayMin, j as arrayMinus, A as arrayRandomElement, o as arrayRemoveElement, p as arraySetElement, y as arrayShuffle, z as arrayShuffleForce, x as arrayShuffleInPlace, u as arraySorted, v as arraySortedNumbers, D as arraySum, n as arraySymmetricDifference, s as arrayToggleInPlace, k as arrayUnion, i as arrayUnique, bs as avg, bq as between, c2 as cloneJsonObject, c1 as cloneObject, bA as cmp, bz as composeOrderby, G as createArray, d3 as createLocalChannelPair, cv as createPromise, dp as createPromiseProxy, h as csv, at as currency, aW as dateStringToDays, aV as day, aA as dayDay, aQ as dayDiff, aE as dayFromAny, aG as dayFromDate, aH as dayFromDateGMT, aL as dayFromParts, aM as dayFromString, aJ as dayFromTimestamp, aD as dayFromToday, az as dayMonth, aN as dayMonthStart, aP as dayOffset, aC as dayToDate, aF as dayToDateGMT, aB as dayToParts, aK as dayToString, aI as dayToTimestamp, ay as dayYear, aO as dayYearStart, cL as debounce, aZ as decimal, b0 as decimalCentsPart, a_ as decimalFromCents, a$ as decimalToCents, K as decodeBase16, N as decodeBase32, Q as decodeBase58, S as decodeBase62, U as decodeBase64, g as decrypt, b1 as deepEqual, b3 as deepMerge, b2 as deepStripUndefinedInPlace, e as deriveKeyPbkdf2, dK as detect, d as digest, c0 as empty, I as encodeBase16, M as encodeBase32, P as encodeBase58, R as encodeBase62, T as encodeBase64, bW as encodeQuery, f as encrypt, bR as endSortWeight, bY as ensureKey, bZ as ensureKeyAsync, a5 as equalBinary, b4 as escapeHTML, bD as escapeRegExp, dB as fetchBasic, dC as fetchJson, dG as fetchOptionsBasicAuth, dE as fetchOptionsFormURLEncoded, dF as fetchOptionsJson, dD as fetchText, ar as fixBrokenUth8String, aT as forEachDay, c5 as forTimes, ap as formatMessages, dR as formatMilliseconds, a4 as fromBase64, ac as fromCamelCase, a1 as fromHex, dJ as getGlobal, cM as getGlobalContext, d9 as getGlobalEmitter, cO as getGlobalLogger, cX as getNamespaceFilterString, dI as getNavigator, bl as getSecureRandom, bm as getSecureRandomIfPossible, dQ as getTimestamp, dH as getWindow, dz as httpMethod, cx as immediate, b9 as isArray, bf as isBoolean, dL as isBrowser, bG as isEven, bF as isHalf, bd as isInteger, cN as isLocalHost, bg as isNullOrUndefined, bc as isNumber, b7 as isObject, bu as isPrime, bt as isPrimeRX, b8 as isPrimitive, cE as isPromise, ba as isRecord, be as isSafeInteger, bb as isString, cB as isTimeout, bh as isUint8Array, $ as joinToUint8Array, bk as jsonStringify, bj as jsonStringifySafe, bi as jsonStringifySorted, a6 as jsonToUint8Array, b$ as last, db as lazyListener, bU as linkifyPlainText, c3 as memoize, c4 as memoizeAsync, da as messages, bS as moveSortWeight, bw as objectMap, bx as objectMergeDisposable, dA as parseBasicAuth, dS as parseDate, cZ as parseLogLevel, by as parseOrderby, bX as parseQuery, dM as platform, cF as promisify, e3 as qid, bn as randomBoolean, bp as randomFloat, bo as randomInt, r as randomUint8Array, c7 as regExpEscape, c6 as regExpString, aq as renderMessages, bI as roundDown, bL as roundHalfAwayFromZero, bM as roundHalfDown, bN as roundHalfEven, bK as roundHalfOdd, bO as roundHalfTowardsZero, bJ as roundHalfUp, bH as roundUp, bv as seededRandom, b_ as size, cw as sleep, bT as sortedItems, bB as sortedOrderby, bQ as startSortWeight, ad as stringToBoolean, af as stringToFloat, ae as stringToInteger, X as stringToUInt8Array, e6 as suid, e5 as suidBytes, e8 as suidBytesDate, e7 as suidDate, br as sum, cK as throttle, cz as timeout, cy as timeoutReached, cA as timoutError, a2 as toBase64, a3 as toBase64Url, an as toBool, a9 as toCamelCase, aa as toCapitalize, ab as toCapitalizeWords, ak as toFloat, a0 as toHex, bV as toHumanReadableUrl, al as toInt, am as toString, Z as toUint8Array, bC as toValidFilename, aU as today, cC as tryTimeout, e2 as uname, b5 as unescapeHTML, cn as useAsyncMutex, H as useBase, cf as useDefer, cc as useDispose, ce as useDisposer, cj as useEventListener, dN as useExitHandler, ci as useInterval, c_ as useLevelFilter, dq as useMessageHub, cm as useMutex, cY as useNamespaceFilter, ct as usePool, ds as usePubSub, dy as useRPC, ch as useTimeout, dW as uuid, e1 as uuid32Decode, e0 as uuid32Encode, dV as uuid32bit, d$ as uuidB32, dU as uuidBytes, dZ as uuidDecode, d_ as uuidDecodeV4, dX as uuidEncode, dY as uuidEncodeV4, e4 as uuidv4, ag as valueToBoolean, ai as valueToFloat, ah as valueToInteger, aj as valueToString, cD as waitOn } from './uuid-f7f2f4f2.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare type csvOptions = {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
